Subject: Re: bug#8724: 23.2; js-mode imenu should be more thorough

From: Dmitry Gutov <[email-masked]>
Date: Thu, 11 Jan 2024 02:19:27 +0200

On 10/01/2024 13:55, Stefan Kangas wrote:
> Dmitry Gutov <[email-masked]> writes:
> 
>> On 02.06.2021 10:58, Lars Ingebrigtsen wrote:
>>> This was nine years ago -- was there any progress with this?  (It sounds
>>> like a good change, but I haven't looked at the code.)
>>
>> Someone should really work in that direction, since in these nine years JS has
>> grown more ways to define a function: e.g. arrow functions, or 'const <function
>> name> = ...'.
>>
>> I've tried simply replacing the definition.
>>
>> The patch kinda works, except I'm not sure about the (top) and (bottom) items
>> that it adds (we don't have any precedent for this, so I vote no), and there's
>> some sort of duplication of the entries: I see both (top) and the enclosed
>> function name repeated an extra time in the imenu index.
> 
> Did you make any further progress here?

Sorry, I did not.

It's still marked as "todo" in my email folder, but not of high 
priority, so far.

And in this day and year, someone might give a shot at porting 
js2-mode's imenu generator (quite featureful, I should say) to 
tree-sitter's API (in js-ts-mode).